summaryrefslogtreecommitdiff
path: root/build.sh
diff options
context:
space:
mode:
Diffstat (limited to 'build.sh')
-rwxr-xr-xbuild.sh97
1 files changed, 48 insertions, 49 deletions
diff --git a/build.sh b/build.sh
index ab7a1faa37..0880732a4f 100755
--- a/build.sh
+++ b/build.sh
@@ -28,7 +28,7 @@ build_dir_Linux()
build_dir_CYGWIN()
{
- echo build-vc120
+ echo build-vc120-${AUTOBUILD_ADDRSIZE}
}
viewer_channel_suffix()
@@ -114,18 +114,18 @@ package_llphysicsextensions_tpv()
tpv_status=0
if [ "$variant" = "Release" ]
then
- llpetpvcfg=$build_dir/packages/llphysicsextensions/autobuild-tpv.xml
- "$autobuild" build --quiet --config-file $llpetpvcfg -c Tpv
+ test -r "$build_dir/packages/llphysicsextensions/autobuild-tpv.xml" || fatal "No llphysicsextensions_tpv autobuild configuration found"
+ tpvconfig=$(native_path "$build_dir/packages/llphysicsextensions/autobuild-tpv.xml")
+ "$autobuild" build --quiet --config-file "$tpvconfig" -c Tpv || fatal "failed to build llphysicsextensions_tpv"
# capture the package file name for use in upload later...
PKGTMP=`mktemp -t pgktpv.XXXXXX`
trap "rm $PKGTMP* 2>/dev/null" 0
- "$autobuild" package --quiet --config-file $llpetpvcfg --results-file "$(native_path $PKGTMP)"
+ "$autobuild" package --quiet --config-file "$tpvconfig" --results-file "$(native_path $PKGTMP)" || fatal "failed to package llphysicsextensions_tpv"
tpv_status=$?
if [ -r "${PKGTMP}" ]
then
- cat "${PKGTMP}" >> "$build_log"
- eval $(cat "${PKGTMP}") # sets autobuild_package_{name,filename,md5}
+ . "${PKGTMP}" # sets autobuild_package_{name,filename,md5}
autobuild_package_filename="$(shell_path "${autobuild_package_filename}")"
echo "${autobuild_package_filename}" > $build_dir/llphysicsextensions_package
fi
@@ -142,10 +142,14 @@ build()
local variant="$1"
if $build_viewer
then
+ begin_section "autobuild $variant"
"$autobuild" build --no-configure -c $variant || fatal "failed building $variant"
+ echo true >"$build_dir"/build_ok
+ end_section "autobuild $variant"
+ begin_section "extensions $variant"
# Run build extensions
- if [ $build_ok -eq 0 -a -d ${build_dir}/packages/build-extensions ]
+ if [ -d ${build_dir}/packages/build-extensions ]
then
for extension in ${build_dir}/packages/build-extensions/*.sh
do
@@ -157,10 +161,10 @@ build()
# *TODO: Make this a build extension.
package_llphysicsextensions_tpv || fatal "failed building llphysicsextensions packages"
+ end_section "extensions $variant"
- echo true >"$build_dir"/build_ok
else
- echo "Skipping build due to configuration build_viewer=${build_viewer}"
+ record_event "Skipping build due to configuration build_viewer=${build_viewer}"
echo true >"$build_dir"/build_ok
fi
}
@@ -176,13 +180,9 @@ then
exit 1
fi
-# Check to see if we're skipping the platform
-if ! eval '$build_'"$arch"
-then
- record_event "building on architecture $arch is disabled"
- pass
-fi
+initialize_build # provided by master buildscripts build.sh
+begin_section "autobuild initialize"
# ensure AUTOBUILD is in native path form for child processes
AUTOBUILD="$(native_path "$AUTOBUILD")"
# set "$autobuild" to cygwin path form for use locally in this script
@@ -194,7 +194,16 @@ then
fi
# load autobuild provided shell functions and variables
-eval "$("$autobuild" --quiet source_environment)"
+"$autobuild" --quiet source_environment > "$build_log_dir/source_environment"
+begin_section "dump source environment commands"
+cat "$build_log_dir/source_environment"
+end_section "dump source environment commands"
+
+begin_section "execute source environment commands"
+. "$build_log_dir/source_environment"
+end_section "execute source environment commands"
+
+end_section "autobuild initialize"
# something about the additional_packages mechanism messes up buildscripts results.py on Linux
# since we don't care about those packages on Linux, just zero it out, yes - a HACK
@@ -203,10 +212,9 @@ then
export additional_packages=
fi
-# dump environment variables for debugging
-begin_section "Environment"
-env|sort
-end_section "Environment"
+python_cmd "$helpers/codeticket.py" addinput "Viewer Channel" "${viewer_channel}"
+
+initialize_version # provided by buildscripts build.sh; sets version id
# Now run the build
succeeded=true
@@ -214,9 +222,6 @@ build_processes=
last_built_variant=
for variant in $variants
do
- eval '$build_'"$variant" || continue
- eval '$build_'"$arch"_"$variant" || continue
-
# Only the last built arch is available for upload
last_built_variant="$variant"
@@ -232,6 +237,9 @@ do
then
begin_section "Build $variant"
build "$variant" "$build_dir"
+ end_section "Build $variant"
+
+ begin_section "post-build $variant"
if `cat "$build_dir/build_ok"`
then
case "$variant" in
@@ -239,10 +247,10 @@ do
if [ -r "$build_dir/autobuild-package.xml" ]
then
begin_section "Autobuild metadata"
- upload_item docs "$build_dir/autobuild-package.xml" text/xml
+ python_cmd "$helpers/codeticket.py" addoutput "Autobuild Metadata" "$build_dir/autobuild-package.xml" --mimetype text/xml
if [ "$arch" != "Linux" ]
then
- record_dependencies_graph # defined in buildscripts/hg/bin/build.sh
+ record_dependencies_graph "$build_dir/autobuild-package.xml" # defined in buildscripts/hg/bin/build.sh
else
record_event "TBD - no dependency graph for linux (probable python version dependency)"
fi
@@ -255,12 +263,12 @@ do
if [ -r "$build_dir/doxygen_warnings.log" ]
then
record_event "Doxygen warnings generated; see doxygen_warnings.log"
- upload_item log "$build_dir/doxygen_warnings.log" text/plain
+ python_cmd "$helpers/codeticket.py" addoutput "Doxygen Log" "$build_dir/doxygen_warnings.log" --mimetype text/plain ## TBD
fi
if [ -d "$build_dir/doxygen/html" ]
then
tar -c -f "$build_dir/viewer-doxygen.tar.bz2" --strip-components 3 "$build_dir/doxygen/html"
- upload_item docs "$build_dir/viewer-doxygen.tar.bz2" binary/octet-stream
+ python_cmd "$helpers/codeticket.py" addoutput "Doxygen Tarball" "$build_dir/viewer-doxygen.tar.bz2"
fi
;;
*)
@@ -270,7 +278,8 @@ do
else
record_failure "Build of \"$variant\" failed."
fi
- end_section "Build $variant"
+ end_section "post-build $variant"
+
else
record_event "configure for $variant failed: build skipped"
fi
@@ -290,7 +299,7 @@ then
if $build_viewer_deb && [ "$last_built_variant" == "Release" ]
then
begin_section "Build Viewer Debian Package"
- have_private_repo=false
+
# mangle the changelog
dch --force-bad-version \
--distribution unstable \
@@ -320,11 +329,12 @@ then
# upload debian package and create repository
begin_section "Upload Debian Repository"
for deb_file in `/bin/ls ../packages_public/*.deb ../*.deb 2>/dev/null`; do
- upload_item debian $deb_file binary/octet-stream
+ deb_pkg=$(basename "$deb_file" | sed 's,_.*,,')
+ python_cmd "$helpers/codeticket.py" addoutput "Debian $deb_pkg" $deb_file
done
for deb_file in `/bin/ls ../packages_private/*.deb 2>/dev/null`; do
- upload_item debian_private $deb_file binary/octet-stream
- have_private_repo=true
+ deb_pkg=$(basename "$deb_file" | sed 's,_.*,,')
+ python_cmd "$helpers/codeticket.py" addoutput "Debian $deb_pkg" "$deb_file" --private
done
create_deb_repo
@@ -336,14 +346,6 @@ then
mv $build_log_dir/$debian_repo_type $build_log_dir/${debian_repo_type}_pushed
fi
done
-
- if [ $have_private_repo = true ]; then
- eval "$python_command \"$redirect\" '\${private_S3PROXY_URL}${S3PREFIX}repo/$repo/rev/$revision/index.html'"\
- >"$build_log_dir/private.html" || fatal generating redirect
- upload_item global_redirect "$build_log_dir/private.html" text/html
-
- fi
-
end_section "Upload Debian Repository"
else
@@ -359,7 +361,7 @@ if $succeeded
then
if $build_viewer
then
- begin_section Upload Installer
+ begin_section "Uploads"
# Upload installer
package=$(installer_$arch)
if [ x"$package" = x ] || test -d "$package"
@@ -368,9 +370,7 @@ then
succeeded=$build_coverity
else
# Upload base package.
- upload_item installer "$package" binary/octet-stream
- upload_item quicklink "$package" binary/octet-stream
- [ -f $build_dir/summary.json ] && upload_item installer $build_dir/summary.json text/plain
+ python_cmd "$helpers/codeticket.py" addoutput Installer --output "$package"
# Upload additional packages.
for package_id in $additional_packages
@@ -378,8 +378,7 @@ then
package=$(installer_$arch "$package_id")
if [ x"$package" != x ]
then
- upload_item installer "$package" binary/octet-stream
- upload_item quicklink "$package" binary/octet-stream
+ python_cmd "$helpers/codeticket.py" addoutput "Installer $package_id" "$package"
else
record_failure "Failed to find additional package for '$package_id'."
fi
@@ -390,7 +389,7 @@ then
# Upload crash reporter files
for symbolfile in $symbolfiles
do
- upload_item symbolfile "$build_dir/$symbolfile" binary/octet-stream
+ python_cmd "$helpers/codeticket.py" addoutput "Symbolfile $(basename "$build_dir/$symbolfile")" "$build_dir/$symbolfile"
done
# Upload the llphysicsextensions_tpv package, if one was produced
@@ -398,7 +397,7 @@ then
if [ -r "$build_dir/llphysicsextensions_package" ]
then
llphysicsextensions_package=$(cat $build_dir/llphysicsextensions_package)
- upload_item private_artifact "$llphysicsextensions_package" binary/octet-stream
+ python_cmd "$helpers/codeticket.py" addoutput "Physics Extensions Package" "$llphysicsextensions_package" --private
fi
;;
*)
@@ -414,7 +413,7 @@ then
done
fi
fi
- end_section Upload Installer
+ end_section "Uploads"
else
record_event "skipping upload of installer"
fi